/*
 *
 * $Source: /filesv/usr/local/proj/sphinx/spx2/src/admin/RCS/dump_pubkey.c,v $
 *
 *
 *  MODULE NAME:    dump_pubkey.c
 *
 *
 *  AUTHORS:
 *
 *	K. Alagappan
 *
 */

 
/*
 * COPYRIGHT (C) 1992 DIGITAL EQUIPMENT CORPORATION
 * ALL RIGHTS RESERVED
 *
 * "Digital Equipment Corporation authorizes the reproduction,
 * distribution and modification of this software subject to the following
 * restrictions:
 * 
 * 1.  Any partial or whole copy of this software, or any modification
 * thereof, must include this copyright notice in its entirety.
 *
 * 2.  This software is supplied "as is" with no warranty of any kind,
 * expressed or implied, for any purpose, including any warranty of fitness 
 * or merchantibility.  DIGITAL assumes no responsibility for the use or
 * reliability of this software, nor promises to provide any form of 
 * support for it on any basis.
 *
 * 3.  Distribution of this software is authorized only if no profit or
 * remuneration of any kind is received in exchange for such distribution. 
 * 
 * 4.  This software and all application programs are to be used only for
 * non-commercial purposes. However, media costs associated with the
 * distribution of the software or application programs may be recovered.
 *
 */


#include <stdio.h>

#include "BigNum.h"
#include "BigRSA.h"

#include "cdc.h"
#include "random.h"
#include "bigkeygen.h"

char *progname, *rindex();

main(argc,argv)
int     argc;
char    **argv;
{
    static RSAKeyStorage keys ;
    char usernameBuf [50], uidBuf [50], x500NameBuf[50], *cp;
    int uid_len;

    if (argc != 2)
    {
      progname = (cp = rindex(argv[0], '/')) ? cp + 1 : argv[0];
      printf("Usage: %s name \n", argv[0]);
      exit(1);
    }

    strcpy(usernameBuf, argv[1]);

    memset(&keys,0,sizeof(keys));
    
    if (read_pubkey_verbose (usernameBuf, x500NameBuf, uidBuf, &uid_len, &keys)) {
        printf("\nName: %s\n", x500NameBuf);
        printf("\nUID:  \n");
        dumphex(uidBuf,uid_len);
        printf("\nPublic Key:");
        PrintPubKey(&keys);
    }        

BnnClose();
exit(0);
}
